
#include <iostream>
#include <vector>


template<typename T>
void print_vec_ (const char *vec_name,
                 std::vector<T> vec)
  {
    std::cout << vec_name << ":\n";
    for (const T &elem : vec)
      {
        std::cout << '\t';
        if (elem == UINTMAX_MAX)
          {
            std::cout << "-1";
          }
        else
          {
            std::cout << ' ' << elem;
          }
        std::cout << '\n';
      }
    std::cout << std::flush;
  }

#define print_vec(v) print_vec_(#v, v)



void print_loc_ (int src_line,
                 int cur_indx)
  {
    
    std::cout << '[' << src_line;
    if (cur_indx != -1)
      {
        std::cout << ':' << cur_indx;
      }
    std::cout << ']' << std::endl;
  }

#define print_loc(v) print_loc_(__LINE__, v)



template<typename T>
void print_val_ (const char* val_name,
                 T           val_vlue)
  {
    std::cout << val_name << ": ";
    std::cout << val_vlue << '\n';
    std::cout << std::flush;
  }

#define print_val(v) print_val_(#v, v)
